---------------------
-- Object save script
-- By Vectar666
---------------------

--basic functions
function toTable(t,match)
     local cmd = {}
     if not match then
          match = "[^%s]+"
     else
          match = "[^"..match.."]+"
     end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end
--hooks
addhook("parse","objsave_console")
--main funcs
function objsave_save(filename)
	local filestr=""
	local objs=object(0,"table")
	local team,usgn
	if #objs>0 then
		f = assert(io.open("sys/lua/objsaves/"..filename..".sav","w"))
		for i=1,#objs do
			if player(object(i,"player"),"exists") then
				team=player(object(i,"player"),"team")
				usgn=player(object(i,"player"),"usgn")
			else
				team=0
				usgn=0
			end
			filestr=filestr..object(i,"type").." "..object(i,"tilex").." "..object(i,"tiley").." "..object(i,"rot").." "..object(i,"mode").." "..team.." "..object(i,"player").." "..usgn.."\n"
		end
		f:write(filestr)
		f:close()
		print("000255000Saved!")
	else
		print("255000000Save failed: no objects")
	end
end

function objsave_load(filename,mode)
	local prs,usgn,upl
	f = io.open("sys/lua/objsaves/"..filename..".sav","r")
	if (f ~= nil) then
		print("Save exists")
		local i = 0
		for line in f:lines() do
			i = i + 1
			prs=toTable(line)
			if mode==0 then
				parse("spawnobject "..prs[1].." "..prs[2].." "..prs[3].." "..prs[4].." "..prs[5].." "..prs[6].." 0")
			elseif mode==1 then
				parse("spawnobject "..prs[1].." "..prs[2].." "..prs[3].." "..prs[4].." "..prs[5].." "..prs[6].." "..prs[7])
			elseif mode==2 then
				usgn=tonumber(prs[8])
				if tonumber(usgn)>0 then
					upl=0
					for id=1,32 do
						if player(id,"usgn")==usgn then
							upl=id
						end
					end
					parse("spawnobject "..prs[1].." "..prs[2].." "..prs[3].." "..prs[4].." "..prs[5].." "..prs[6].." "..upl)
				else
					parse("spawnobject "..prs[1].." "..prs[2].." "..prs[3].." "..prs[4].." "..prs[5].." "..prs[6].." 0")
				end
			end
		end
		f:close()
		print("000255000Loaded successfully")
	else
		print("255000000Load Failed: File does not exist")
	end
end

--hook funcs
function objsave_console(text)
	local cmd=toTable(text)
	if cmd[1]=="saveobjects" then
		objsave_save(cmd[2])
		return 2
	elseif cmd[1]=="loadobjects" then
		if cmd[3]==nil then cmd[3]="1" end
		objsave_load(cmd[2],tonumber(cmd[3]))
		return 2
	end
end